"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hint = void 0;
var react_1 = __importStar(require("react"));
var utils_1 = require("./utils");
exports.Hint = function (props) {
    var options = props.options, child = props.children, disableHint = props.disableHint;
    var childProps = child.props;
    var mainInputRef = react_1.useRef(null);
    var hintRef = react_1.useRef(null);
    var _a = react_1.useState(''), hint = _a[0], setHint = _a[1];
    react_1.useEffect(function () {
        var _a;
        if (disableHint) {
            return;
        }
        var inputStyle = mainInputRef.current && window.getComputedStyle(mainInputRef.current);
        if (inputStyle && ((_a = hintRef === null || hintRef === void 0 ? void 0 : hintRef.current) === null || _a === void 0 ? void 0 : _a.style)) {
            hintRef.current.style.fontSize = inputStyle.fontSize;
            hintRef.current.style.width = inputStyle.width;
            hintRef.current.style.height = inputStyle.height;
            hintRef.current.style.lineHeight = inputStyle.lineHeight;
            hintRef.current.style.boxSizing = inputStyle.boxSizing;
            hintRef.current.style.margin = utils_1.interpolateStyle(inputStyle, 'margin');
            hintRef.current.style.padding = utils_1.interpolateStyle(inputStyle, 'padding');
            hintRef.current.style.borderStyle = utils_1.interpolateStyle(inputStyle, 'border', 'style');
            hintRef.current.style.borderWidth = utils_1.interpolateStyle(inputStyle, 'border', 'width');
        }
    });
    var getHint = function (text) {
        if (!text || text === '') {
            return '';
        }
        var match = options.filter(function (x) { return x !== text && x.startsWith(text); }).sort()[0];
        return match || '';
    };
    var onChange = function (e) {
        setHint(getHint(e.target.value));
        childProps.onChange && childProps.onChange(e);
    };
    var onBlur = function (e) {
        setHint('');
        childProps.onBlur && childProps.onBlur(e);
    };
    var RIGHT = 39;
    var onKeyDown = function (e) {
        if (e.keyCode === RIGHT) {
            // For selectable input types ("text", "search"), only select the hint if
            // it's at the end of the input value. For non-selectable types ("email",
            // "number"), always select the hint.
            var isNonSelectableType = e.currentTarget.selectionEnd == null;
            var cursorIsAtTextEnd = isNonSelectableType
                ? true
                : e.currentTarget.selectionEnd === e.currentTarget.value.length;
            if (cursorIsAtTextEnd && hint !== '' && e.currentTarget.value !== hint) {
                e.currentTarget.value = hint;
                childProps.onChange(e);
                setHint('');
            }
        }
        childProps.onKeyDown && childProps.onKeyDown(e);
    };
    var mainInput = react_1.cloneElement(child, __assign(__assign({}, childProps), { onChange: onChange,
        onBlur: onBlur,
        onKeyDown: onKeyDown, ref: utils_1.mergeRefs(childProps.ref, mainInputRef) }));
    return (react_1.default.createElement("div", { className: "rah-input-wrapper", style: {
            position: 'relative',
            display: 'inline-block'
        } }, disableHint
        ? child
        : (react_1.default.createElement(react_1.default.Fragment, null,
            mainInput,
            react_1.default.createElement("input", { className: "rah-input-hint", defaultValue: hint, ref: hintRef, style: {
                    backgroundColor: 'transparent',
                    borderColor: 'transparent',
                    boxShadow: 'none',
                    color: 'rgba(0, 0, 0, 0.35)',
                    pointerEvents: 'none',
                    position: 'absolute',
                    top: 0,
                    left: 0
                }, tabIndex: -1 })))));
};
