"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.interpolateStyle = exports.mergeRefs = void 0;
function mergeRefs() {
    var refs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        refs[_i] = arguments[_i];
    }
    var filteredRefs = refs.filter(Boolean);
    if (!filteredRefs.length)
        return null;
    if (filteredRefs.length === 0)
        return filteredRefs[0];
    return function (inst) {
        for (var _i = 0, filteredRefs_1 = filteredRefs; _i < filteredRefs_1.length; _i++) {
            var ref = filteredRefs_1[_i];
            if (typeof ref === 'function') {
                ref(inst);
            }
            else if (ref) {
                ref.current = inst;
            }
        }
    };
}
exports.mergeRefs = mergeRefs;
;
// IE doesn't seem to get the composite computed value (eg: 'padding',
// 'borderStyle', etc.), so generate these from the individual values.
function interpolateStyle(styles, attr, subattr) {
    if (subattr === void 0) { subattr = ''; }
    // Title-case the sub-attribute.
    if (subattr) {
        subattr = subattr.replace(subattr[0], subattr[0].toUpperCase());
    }
    return ['Top', 'Right', 'Bottom', 'Left']
        // @ts-ignore: (attr + dir + subattr) property cannot be determined at compile time
        .map(function (dir) { return styles[attr + dir + subattr]; })
        .join(' ');
}
exports.interpolateStyle = interpolateStyle;
